/////////////////////////////////////////////////////////////////////////////////  
//Programm "Dynamische Geometrie" (hier in der Version mit Schnittpunkten)
//zur Erläuterung der objektorientierten Programmierung
/////////////////////////////////////////////////////////////////////////////
//Attribute:
////////////////////////////////////////////////////////////////////////
private ArrayList<GeoObject> geoObjects = new ArrayList<GeoObject>();
private ArrayList<Point> selectedPoints= new ArrayList<Point>();
private ArrayList<Point> fixPoints= new ArrayList<Point>();
private ArrayList<Line> selectedLines = new ArrayList<Line>();
private Point dPoint = null;
private Point point1 = null;
private Point point2 = null;
private Point point3 = null;
private Point point4 = null;
private Point p = null;
private Line sLine = null;
private int w, h;
private int r,g,b;
///////////////////////////////////////////////
//In setup und draw gibt es nicht viel zu tun!
///////////////////////////////////////////////
void setup() {
 size(800,1000);
}

void draw() {
  background(255);
  for (GeoObject go : geoObjects ) {
    go.display(); 
  } 
  gitterZeichnen(); 
}
//Das Gitter hilft der Orientierung in der Zeichenebene 
private void gitterZeichnen(){
  strokeWeight(1);
  stroke(200);
  for( int i =0; i<800;i+=100){ //senkrechte Linien
    line(i,0,i,1000);
  }
  for( int j =0; j<1000;j+=100){ //waagrechte Linien
    line(0,j,800,j);
  }  
}

//Wird in der Nähe eines vorhandenen Punktes links-geklickt,...
//Die mousePressed-Methode ist im Skript ausführich erklärt
void mousePressed() {  
  if( mouseButton == LEFT){
  dPoint = null;
  for (GeoObject go : geoObjects ) {
    if (go instanceof Point ){
      Point p = (Point) go;
      double d = p.abstandZu(mouseX, mouseY);
      if (d < 6 &&  !fixPoints.contains(p)) {
        dPoint = p; 
      }
    } 
  }  
  if (dPoint == null) {
    Point newPoint = new Point(mouseX, mouseY);
    newPoint.setfarbe(color(r,g,b));//kann weggelassen werden, wenn Punkte grundsätzlich schwarz gezeichnet werden sollen
    geoObjects.add(newPoint);    
  }  else {
     if (key == CODED && keyCode == SHIFT){
        if (dPoint.getSelected()) {
          dPoint.setSelected(false);
          selectedPoints.remove(dPoint);
        } else {
          dPoint.setSelected(true);
          selectedPoints.add(dPoint);
        }
     }    
   }
  }
  //Gerade markieren
  if( mouseButton == RIGHT){
  sLine = null;
  for (GeoObject go : geoObjects ) {
    if (go instanceof Line){
      Line l = (Line) go;
      int x5 =l.getP5().getX();int y5 =l.getP5().getY();
      int x6 =l.getP6().getX();int y6 =l.getP6().getY();
     
      double d = Math.abs(l.yWert(x5,y5,x6,y6,mouseX)- mouseY); 
     
      if (d <60) {  println(d);
        sLine = l; 
        if (sLine.getSelected()) {
            sLine.setSelected(false);
            selectedLines.remove(sLine);
            println("oben");
          } else {
            sLine.setSelected(true);
            selectedLines.add(sLine); 
            println("unten");
        }
      }      
    } 
   }
   //Dient nur der Kontrolle
  println("sPs:  "+selectedPoints.size()+"  sLs:  "+selectedLines.size()); 
  if(selectedLines.size()==2){println(selectedLines.get(0).getP5().getY()); println(selectedLines.get(1).getP5().getY());}
  }
  
}
//Methode sorgt dafür, dass beim Löschen eines Punktes keine Lines ohne Punkte gezeichnet werden          
public void deleteObjects(){
   ArrayList<GeoObject> objekteZuLoeschen = new ArrayList<GeoObject>();
   for (Point p : selectedPoints) {     
      objekteZuLoeschen.add(p);             
      for (GeoObject o : geoObjects) { 
        if (o.abhaengigVon(p)) {         
          objekteZuLoeschen.add(o);        
        } 
       }
      }                                                     
   for (GeoObject o : objekteZuLoeschen) {   
      geoObjects.remove(o);           
   } 
}

 //Der Punkt wird zum dPoint und kann verschoben werden 
 //Aber nur dann, wenn nicht eine Gerade markiert werden soll( rechter Mause-Button).
public void mouseDragged() {
  if(dPoint != null  && ! (mouseButton == RIGHT)) {
    dPoint.setX(mouseX);
    dPoint.setY(mouseY);
  } 
}


//Damit wählt man das zu zeichnende Objekt bzw. die Farbe des Objekts 
void keyPressed(){
  //Farbwahl
  if(key == 'R'){r = 255;}
  if(key == 'G'){g = 255;}
  if(key == 'B'){b = 255;}
  if(key == 'Z'){r=0; g=0; b=0;}
  //Strecke (Line) erzeugen
  if (key == 'l'){              
   if (selectedPoints.size() == 2) {
      Line line = new Line(selectedPoints.get(0), selectedPoints.get(1));
      line.setfarbe(color(r,g,b));
      geoObjects.add(line);
    } 
    selectedPointsLoeschen();
  } 
  //Gerade (StraightLine) erzeugen
  if (key == 'g'){
   if (selectedPoints.size() == 2) {
      StraightLine gerade = new StraightLine(selectedPoints.get(0), selectedPoints.get(1));
      gerade.setfarbe(color(r,g,b));
      geoObjects.add(gerade);
    } 
    selectedPointsLoeschen();
  } 
  
  //Mittelsenkrecht erzeugen 
  if (key == 'm'){
    if (selectedPoints.size() == 2) {
      StraightLineMS msenkrechte = new StraightLineMS(selectedPoints.get(0), selectedPoints.get(1));
      msenkrechte.setfarbe(color(r,g,b));
      geoObjects.add(msenkrechte);
    } 
    selectedPointsLoeschen();
  } 
  
  //Seitenhalbierende erzeugen
  if (key == 'h'){
   if (selectedPoints.size() == 3) {
      StraightLineSH shalbierende = new StraightLineSH(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      shalbierende.setfarbe(color(r,g,b));
      geoObjects.add(shalbierende);
      geoObjects.add(shalbierende.getP4());
    }   
    selectedPointsLoeschen();
  } 
  //Rechteck erzeugen
  if (key == 'r'){
   if (selectedPoints.size() == 2) {
      Rectangle rechteck = new Rectangle(selectedPoints.get(0), selectedPoints.get(1));
      rechteck.setfarbe(color(r,g,b));
      geoObjects.add(rechteck);
    } 
    selectedPointsLoeschen();
  } 
  //Kreis erzeugen
  if (key == 'c'){
   if (selectedPoints.size() == 2) {
      CircleLine kreis = new CircleLine(selectedPoints.get(0), selectedPoints.get(1));
      kreis.setfarbe(color(r,g,b));
      geoObjects.add(kreis);
    } 
    selectedPointsLoeschen();
  } 
  //Ellipse erzeugen
  if (key == 'e'){
   if (selectedPoints.size() == 3) {
      EllipseLine ellipse = new EllipseLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      ellipse.setfarbe(color(r,g,b));
      geoObjects.add(ellipse);
    } 
    selectedPointsLoeschen();
  } 
  //Polygon erzeugen
  if (key == 'y'){
   if (selectedPoints.size() >= 3) {    
      Polygon poly = new Polygon(selectedPoints);
      poly.setfarbe(color(r,g,b));
      geoObjects.add(poly);
    } 
    selectedPointsLoeschen();
  } 
  //Parallele erzeugen
  if (key == 'p'){
   if (selectedPoints.size() == 3) {
     
      ParallelLine parallele = new ParallelLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      parallele.setfarbe(color(r,g,b));
      geoObjects.add(parallele);
    } 
    selectedPointsLoeschen();
  } 
  //Winkelhalbierende erzeugen
 if (key == 'w'){
   if (selectedPoints.size() == 3) {
      StraightLineWH winkelhalbierende = new StraightLineWH(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      winkelhalbierende.setfarbe(color(r,g,b));
      geoObjects.add(winkelhalbierende);
    } 
    selectedPointsLoeschen();
  } 
  //Lot erzeugen
  if (key == 'o'){
   if (selectedPoints.size() == 3) {
      PerpendicularLine lot= new PerpendicularLine(selectedPoints.get(0), selectedPoints.get(1), selectedPoints.get(2));
      lot.setfarbe(color(r,g,b));
      geoObjects.add(lot);
    } 
    selectedPointsLoeschen();
  } 
  //Schnittobjekt erzeugen
  if (key == 'q'){
     if (selectedLines.size() == 2){ 
       
       point1 = selectedLines.get(0).getP5();point2 = selectedLines.get(0).getP6();
       
       point3 = selectedLines.get(1).getP5();point4 = selectedLines.get(1).getP6(); 
      
       selectedLinesLoeschen(); 
    
    
       CutObject cut = new CutObject(point1,point2,point3,point4);
       cut.setfarbe(color(r,g,b));
       geoObjects.add(cut);
   
     
     } 
  } 
  // Neuen Punkt an Gerade binden
  if (key == 'b'){ 
     if (selectedLines.size() == 1 && selectedPoints.size()==1){ 
       p = selectedPoints.get(0); geoObjects.add(p);
      selectedLines.get(0).setPointP7(p);  
      geoObjects.remove(selectedPoints.get(0));
       selectedLinesLoeschen();
      selectedPointsLoeschen();     
     }
  } 
  //Punkt löschen
  if (key == 'd'){
   if (selectedPoints.size() >= 0) {
      deleteObjects();
    } 
    selectedPointsLoeschen();
   } 
   
     //VertexCurve erzeugen
   if (key == 'v'){
   if (selectedPoints.size() >= 4) {    
      VertexCurve vertexCurve = new VertexCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(vertexCurve);
    } 
    selectedPointsLoeschen();
  } 
  
  //BezierCurve erzeugen
   if (key == 'x'){
   if (selectedPoints.size() == 4) {    
      BezierCurve bezierCurve = new BezierCurve(selectedPoints);
     // Farbe ist fest eingestellt
      geoObjects.add(bezierCurve);
    } 
    selectedPointsLoeschen();
  } 
  
}//Ende keyPressed()

//markierte Punkte löschen
private void selectedPointsLoeschen(){
 for (Point p: selectedPoints) {
      p.setSelected(false);
 } 
 selectedPoints.clear();
 }
 //markierte Geraden löschen
 private void selectedLinesLoeschen(){
 for (Line l: selectedLines) {
      l.setSelected(false);
 } 
  selectedLines.clear();
 }
 
public abstract class GeoObject {  
  //Attribute protected damit in abgeleiteten Klassen 
  //diese nicht erneut erzeugt werden müssen.
  protected color farbe ;
  //Für Geraden und Strecken gilt folgende Systematik:
  //point1 und point2 liegen auf der Geraden, point3 und point4
  //sind Punkte außerhalb der Geraden, die diese aber definieren
  //point5 und point6 sind die Punkte außerhalb des Zeichenbereichs
  //und erzeugen gezeichnet für die Illusion einer Geraden
  //point7 dient der eventuellen Erzeugung eines Punktes auf einer Geraden
  /////////////////////////////////////////////////////////
  protected Point point1 = null;
  protected Point point2 = null;
  protected Point point3 = null;
  protected Point point4 = null;
  protected Point point5 = null;
  protected Point point6 = null;
  protected Point point7 = null; 
  protected Point pCut = null;
  protected int y1,y2,y3,y4,y5,y6,y7;
  protected int x1,x2,x3,x4,x5,x6,x7;
  protected float   m;
  
  
  //Konstruktor  
  public GeoObject() {    
    this.farbe = color(0, 0, 0);
  }
  //Methoden
  public color getfarbe() {
    return farbe;
  }
  
  public void setfarbe(color farbe) {
    this.farbe = farbe;
  }
  
    public boolean abhaengigVon(GeoObject p) {
    return false;
  }
  
  public abstract void display();    

} 

//Siehe Skript
public class Point extends GeoObject{

 //Attribute
 private int x;
 private int y;
 private boolean selected;

 
 
 //Konstruktor
 public Point(int x, int y) {
   super();
   this.x = x;
   this.y = y;
  // println(x,y);
 }

// Anfang Methoden
 public int getX() {
    return x;
 }
  
  public void setX(int x) {
    this.x = x;
  }
  
  public int getY() {
    return y;
  }
  
  public void setY(int y) {
    this.y = y;
  }
  

  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }


  
  public double abstandZu(int mx, int my) {
    int dx = mx - x;
    int dy = my - y;
    double d = Math.sqrt(dx * dx + dy * dy);
    return d;
  }
  
public void display(){
    stroke(0);
    strokeWeight(2);
    if(selected){
      fill(0);
     }  else{fill(255);}    
                               rectMode(CENTER);
     rect(x,y,7,7);
    }

}

//////////////////////////////////////////////////////////
//Damit kann man kubische BezierCurve-Objekte erzeugen  
//und ihr Verhalten studieren
//////////////////////////////////////////////////////////
public class BezierCurve extends VertexCurve {
  
  //Attribute
  protected boolean selected = false;
  protected boolean schnittmodus = false; 
  private ArrayList<Point> kurvenPunkte= new ArrayList<Point>();
  private int numberOfPoints;
  //Koordinaten der Ankerpunkte auf der Kurve
  private float x1 = 0;
  private float y1 = 0;
  private float x2 = 0;
  private float y2 = 0;
  //Kontrollpunkte
  private float a1 = 0;
  private float b1 = 0;
  private float a2 = 0;
  private float b2 = 0;
  
  public BezierCurve(ArrayList<Point> curvePoints) {
    super(curvePoints);
     numberOfPoints = curvePoints.size();
      for (int i = 0; i < numberOfPoints; i++) {
        kurvenPunkte.add(curvePoints.get(i));
      }
       println(curvePoints.get(0).x, curvePoints.get(0).y);
    }
      
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == kurvenPunkte.get(0)) || (p == kurvenPunkte.get(1)) || (p == kurvenPunkte.get(2)) || (p == kurvenPunkte.get(3));
    
     return abhaengig;  
  }
  
  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }
   
 //display-Methode für VertexCurve
 public void display(){
   //fill(255,0,0); //interessante Erweiterung! Ausprobieren!
   x1= kurvenPunkte.get(0).getX(); y1 = kurvenPunkte.get(0).getY();
   a1= kurvenPunkte.get(1).getX(); b1 = kurvenPunkte.get(1).getY();
   a2= kurvenPunkte.get(2).getX(); b2 = kurvenPunkte.get(2).getY();
   x2= kurvenPunkte.get(3).getX(); y2 = kurvenPunkte.get(3).getY();
   strokeWeight(1); stroke(0,0,255);  
   beginShape();
   vertex(x1,y1);
   bezierVertex(a1,b1,a2,b2,x2,y2);
   endShape();
   stroke(0,255,255);
   line(x1,y1,a1,b1);
   line(a2,b2,x2,y2);
 } 
}

//////////////////////////////////////////////
//Klasse CircleLine (Kreis) wird erst in dieser 
//Version, in der Schnittpunkte von Geraden eine
//Rolle spielen, von Rectangle abgeleitet. Zuvor waren 
//bis auf Point und Polygon alle Klassen von Line abgeleitet.
//Schnittpunkte bestimmen wir aber nur zwischen Geraden.
//Daher sind nun alle Klassen unterhalb von Line
//zur Schnittpunkt-Bestimmung zugelassen.
///////////////////////////////////////////////////////
public class CircleLine extends Rectangle {
  
  // Anfang Attribute
  private int  x1, y1, x2, y2 ;
  private float r;
 
//Konstruktor  
  public CircleLine(Point point1, Point point2) {
    super(point1, point2);
    this.point1=point1;
    this.point2=point2;
  }
  
//"abhängig von" definieren  
public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2) ;    
     return abhaengig;  
  }
  
//Überschriebene Methode display()
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    x1 = point1.getX();
    y1 = point1.getY();
    x2 = point2.getX();
    y2 = point2.getY();
    r = (float)Math.sqrt((y2-y1)*(y2-y1) + (x2-x1)*(x2-x1));//Radius
    //Eine Ellipse mit gleichgroßen Hauptachsen ist ein Kreis
    ellipseMode(RADIUS);
    noFill();
    ellipse(x1,y1,r,r);
 } 
 
}

//////////////////////////////////////////////////////////////////////////////
//CutObject dient zur Verwaltung zweier (beliebiger) sich schneidender Geraden
//////////////////////////////////////////////////////////////////////////////
private Point point5a = null;
private Point point5b = null;
private Point point6a = null;
private Point point6b = null;

private int xCut, yCut;
//protected boolean selected = false;

public class CutObject extends GeoObject {

  public CutObject (Point point1, Point point2, Point point3, Point point4) {
    super();
    this.point1 = point1;
    this.point2 = point2;
    this.point3 = point3;
    this.point4 = point4;
    point5a = new Point(-10, yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), -10));
    point6a = new Point(1010, yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), 1010));
    point5b = new Point(-10, yWert(point3.getX(), point3.getY(), point4.getX(), point4.getY(), -10));
    point6b = new Point(1010, yWert(point3.getX(), point3.getY(), point4.getX(), point4.getY(), 1010));
    pCut = berechneSchnittpunkt(point1.getX(), point1.getY(), point2.getX(), point2.getY(), point3.getX(), point3.getY(), point4.getX(), point4.getY());
    geoObjects.add(pCut);  println(pCut.getX() + "   "+pCut.getY());
  }

  public int yWert(int x1, int y1, int x3, int y3, int x) {
    float s1 =  float((y3-y1)*x)/float(x3-x1);
    float s2 =  float(x3*y1-x1*y3)/float(x3-x1);
    float result = s1 + s2;
    return int(result);
  }

  public Point berechneSchnittpunkt(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4) {
    float m1 =(y2-y1)/(x2-x1);
    float m2 =(y4-y3)/(x4-x3);
    float x = (m1*x1-m2*x3-y1+y3)/(m1-m2) ;
    float y = m1*x - m1*x1 + y1;
    Point p = new Point(int(x), int(y));
    return p;
  }
//Die beiden sich schneidende Geraden gibt es schon unterhalb von Line
//denn die Punkte point1-point7 sind protected und gelten daher in allen 
//Klassen unterhalb GeoObject. Eine weitere Zeichnung line(.....) entfällt daher.
 public void display(){  
  farbe = this.getfarbe();
  stroke(farbe);
  strokeWeight(1);  
  point5a.setY(yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(),-10));
  point6a.setY(yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(), 1010));
  point5b.setY(yWert(point3.getX(),point3.getY(),point4.getX(), point4.getY(),-10));
  point6b.setY(yWert(point3.getX(),point3.getY(),point4.getX(), point4.getY(), 1010));
  xCut = berechneSchnittpunkt(point5a.getX(),point5a.getY(),point6a.getX(), point6a.getY(),point5b.getX(),point5b.getY(),point6b.getX(), point6b.getY()).getX();
  yCut = berechneSchnittpunkt(point5a.getX(),point5a.getY(),point6a.getX(), point6a.getY(),point5b.getX(),point5b.getY(),point6b.getX(), point6b.getY()).getY();
  pCut.setX(xCut); pCut.setY(yCut); //pCut.display();
 // line(-10,point5a.getY(),1010, point6a.getY());
 }
}

//////////////////////////////////////////////////////
//Klasse EllipseLine (Ellipse) von CircleLine abgeleitet.
//Ein weiterer Punkt wird benötigt.
//Erster Punkt: Mittelpunkt, zweiter Punkt hat kleineren Abstand zum 
//Mittelpunkt als dritter Punkt.
//////////////////////////////////////////////////////////////
public class EllipseLine extends CircleLine {
  
  //Attribute  
  private Point point3 = null;
  private int  x1, y1, x2, y2, x3, y3 ;
  private float a,b, x21, x31, y21, y31;
 
  //Konstruktor
  public EllipseLine(Point point1, Point point2, Point point3) {
    super(point1, point2);
    this.point1=point1;
    this.point2=point2;
    this.point3=point3;
  }
 //"abhängig von" definieren   
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2 || (p == point3));
     return abhaengig;
  }
 //Überschriebene Methode display()
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    x1 = point1.getX();y1 = point1.getY();
    x2 = point2.getX();y2 = point2.getY();    
    x3 = point3.getX();y3 = point3.getY(); 
    x21= (x2-x1)*(x2-x1);
    x31= (x3-x1)*(x3-x1);
    y21= (y2-y1)*(y2-y1);
    y31= (y3-y1)*(y3-y1);
    //Halbachsen a und b
    a= (float)Math.sqrt((x31*y21-x21*y31)/(y21-y31));
    b =(float)Math.sqrt(a*a*y21/(a*a-x21));  
    ellipseMode(RADIUS);
    noFill();
    ellipse(x1,y1,a,b);
 } 
 
}


//Von dieser Klasse werden die Klassen
//ParallelLine, PerpendicularLine, StraightLine,
//StraightLineMS,StraightLineSH und StraightLineWH
//abgeleitet
public class Line extends GeoObject {
  
  //Attribute
  protected boolean selected = false;
  protected boolean schnittmodus = false; 
  
  public Line(Point point1, Point point2) {
    this.point1 = point1;
    this.point2 = point2;
    point5 = point1;
    point6 = point2;
    point7 = new Point(-10,0); //unsichtbar, wenn nicht benutzt
    
  }
  //Die meisten der folgenden Methoden werden auch von
  //den abgeleiteten Klassen benutzt.
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2);
     return abhaengig;  
  }
  
  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }
  
  public void setSchnittmodus(boolean schnittmodus){
    this.schnittmodus = schnittmodus;
  }
  
  public boolean getSchnittmodus(){
    return schnittmodus;
  }
  //Funktion, die aus den gegebenen Punkten die Strecke erzeugt
  public int yWert(int x1, int y1, int x2, int y2, int x){
    float s1 =  float((y2-y1)*x)/float(x2-x1);
    float s2 =  float(x2*y1-x1*y2)/float(x2-x1);
    float result = s1 + s2;
    return int(result);
 }

 public void setPointP1(Point point){   
    point1 = point;
 }
 
 public void setPointP2(Point point){   
    point2 = point;
 }
 //Für alle abgeleiteten Klasse gültig
 public void setPointP7(Point point){
   point7 = point;
 }
 //Für alle abgeleiteten Klassen gültig
 public Point getP1(){return point1;}
 public Point getP2(){return point2;}
 public Point getP3(){return point3;}
 public Point getP4(){return point4;}
 public Point getP5(){return point5;}
 public Point getP6(){return point6;}
 public Point getP7(){return point7;}
 
 //display-Methode für Strecken
 public void display(){
    point5 = point1;
    point6 = point2;
    y7= yWert(point1.getX(),point1.getY(),point2.getX(),point2.getY(),point7.getX());
    point7.setY(round(y7));
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    if (selected) {
      stroke(color(150,0,0));
     }  
    line(point5.getX(),point5.getY(),point6.getX(), point6.getY());
    if (selected) {
      stroke(farbe);
    }
  } 
} 

//////////////////////////////////////////////////////////////////////////////
//Paralle zu einer Geraden (repräsentiert durch zwei Punkte) durch einen Punkt
//////////////////////////////////////////////////////////////////////////////
public class ParallelLine extends StraightLineSH{
 
 
  //Dem Konstruktor werden drei Punkte übergeben
  public ParallelLine(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4; 
    //Mit den außerhalb der Zeicheneben gelegenen Punkten 5 und 6 wird die Paralle gezeichnet
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
    
  }
  //Funktion zur Bestimmung aller Punkte auf der Parallen aus den Punkten 1,3 und 4
  int yWert(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
       m =  float((y3-y2))/float((x3-x2));
      float result = m*(x-x1) + y1;
      return round(result);
  }  
  //Methode aus Line muss hier überschrieben werden.
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point5 || (p == point6));
     return abhaengig;
  }
 //Methode aus Line muss hier überschrieben werden. 
 public void setPointP1(Point point2){   
    point1 = point2;
 }
//überschriebene display-Methode, die die Benutzereingaben zeichnerisch umsetzt.
 public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);  
    point7.setY(round(yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), point7.getX())));
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }

    line(-10,y5,1010, y6);
    
   if (selected) {
   stroke(farbe);
   }
  } 
} 
//////////////////////////////////////////////////////////////////////////////
//Lot auf eine Geraden (repräsentiert durch zwei Punkte) durch einen Punkt
//////////////////////////////////////////////////////////////////////////////
public class PerpendicularLine extends StraightLineSH{

  //Dem Konstruktor werden drei Punkte übergeben
  public PerpendicularLine(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
    
  }
  //Funktion zur Bestimmung aller Punkte des Lots durch Punkt 1 aus den Punkten 1,3 und 4
  int yWert(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
    m =   float(x2-x3)/float((y3-y2));
    float result = m*(x-x1) + y1;
    return int(result);
  }  
  
  //Methode aus Line muss hier überschrieben werden.
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point3 || (p == point4));
     return abhaengig;
  }
 //überschriebene display-Methode, die die Benutzereingaben zeichnerisch umsetzt.
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);    
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));   
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }
   
    line(-10,y5,1010, y6);
  
    if (selected) {
      stroke(farbe);
    }  
  } 
}

/////////////////////////////////////////////////////////////
//Da man die Anzahl der Punkte des Polygons nicht festlegen darf
//muss dem Konstruktor eine ArrayList von Punkten übergeben werden.
//Aus diesen wir eine ArrayList aus Lines aufgebaut.
//////////////////////////////////////////////////////////////
public class Polygon extends GeoObject {
 
  private ArrayList<Line> lines = new ArrayList<Line>();
  
  public Polygon(ArrayList<Point> punkte) {;
    for (int i = 0; i < punkte.size()-1; i++) {
      Line s = new Line(punkte.get(i), punkte.get(i+1));
      lines.add(s);
    } 
    Line s = new Line(punkte.get(punkte.size()-1), punkte.get(0));   
    lines.add(s);
  }
 //überschriebene Methode aus GeoObject
 public boolean abhaengigVon(GeoObject p) {
    boolean abhaengig = false;
    for (Line l : lines) {
      if (l.abhaengigVon(p)) {
        abhaengig = true;
      } 
    } 
    return abhaengig;
  }
  //Kann mit der display-Methode von Line bearbeitet werden.  
  public void display(){
    farbe = this.getfarbe();
    strokeWeight(1);
    for (Line s : lines) {
      s.setfarbe(farbe);
      s.display();
    }    
  } 
} 

//////////////////////////////////////////////////
//Hier (wegen Schnittpunkten von Geraden) von GeoObject abgeleitet
/////////////////////////////////////////////////
public class Rectangle extends GeoObject {
  //Konstruktor
  public Rectangle(Point point1, Point point2) {
    this.point1=point1;
    this.point2=point2;
  }
  
  
   public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2);
     return abhaengig;  
  }
  

  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    x1 = Math.min(point1.getX(),point2.getX());
    y1 = Math.min(point1.getY(),point2.getY());
    x2 = Math.max(point1.getX(),point2.getX());
    y2 = Math.max(point1.getY(),point2.getY());
    rectMode(CORNERS);
    noFill();
    rect(x1,y1,x2,y2);
 } 
 
}

//Siehe Skript
//"Gerade" - erzeugt durch Strecke mit Endpunkten außerhalb des Zeichenbereichs
public class StraightLine extends Line {

  public StraightLine(Point point1, Point point2) {
    super(point1,point2);
    point5 = new Point(-10,yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(),-10));
    point6 = new Point(1010, yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(), 1010));
  }
  
   public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2);
     return abhaengig;  
  }
  

 public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);  
    point7.setY(round(yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), point7.getX())));
    y5= yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));
    y6= yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(), 1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }
  
   
       line(-10,y5,1010, y6);
     
   
     if (selected) {
      stroke(farbe);
   }
 }
} 

////////////////////////////////////////////////////////////////////
//Abgeleitet von Line - aber definiert durch zwei Punkte,
//die nicht auf der Mittelsenkrechten liegen!
///////////////////////////////////////////////////////

public class StraightLineMS extends Line {

  public StraightLineMS(Point point3, Point point4) {
    super(point3,point4);
    this.point3 = point3; x3=point3.getX(); y3=point3.getY();
    this.point4 = point4; x4=point4.getX(); y4=point4.getY();  
    y5= funktionsWert34(x3,y3,x4,y4,-10); 
    y6= funktionsWert34(x3,y3,x4, y4, 1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));      
    point1 = new Point(round((x3+x4-y4+y3)/2),round((y3+y4+x4-x3)/2));    
    point2 = new Point(round((x3+x4+y4-y3)/2),round((y3+y4-x4+x3)/2));
  }
  
   public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point3) || (p == point4);
     return abhaengig;  
  }
  
  
 //Funktion, mit deren Hilfe aus den zwei außerhalb gegebenen Punkten
 //die Mittelsenkrechte definiert werden kann
 int funktionsWert34(int x3, int y3, int x4, int y4, int x){
   float s1 =  float(-(x4-x3)*x)/float(y4-y3);
   float s2 =  float(y4*y4-y3*y3+x4*x4-x3*x3)/float(2*(y4-y3));
   float result = s1 + s2;
   return round(result);
 }  
 //Etwas komplexere display-Methode, weil der rechte Winkel beim
 //verschieben erhalten bleiben muss.
 public void display(){ 
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    point7.setY(round(funktionsWert34(point3.getX(), point3.getY(),point4.getX(), point4.getY(), point7.getX())));
    y5= funktionsWert34(point3.getX(),point3.getY(),point4.getX(), point4.getY(),point5.getX());
    y6= funktionsWert34(point3.getX(),point3.getY(),point4.getX(), point4.getY(), point6.getX());
    point5.setY(round(y5)); point6.setY(round(y6));    
    point1.setX(round((point3.getX()+point4.getX()+point3.getY()-point4.getY())/2));  
    point1.setY(round((-point3.getX()+point4.getX()+point3.getY()+point4.getY())/2));  
    point2.setX(round((point3.getX()+point4.getX()-point3.getY()+point4.getY())/2));  
    point2.setY(round((point3.getX()-point4.getX()+point3.getY()+point4.getY())/2));  
    if (selected) {
      stroke(color(150,0,0));       
    }
     
    line(-10,y5,1010, y6);
     
    stroke(color(0));
    }
 
}   

///////////////////////////////////////////////////////////
//Seitenhalbierende durch drei Punkte definiert.
////////////////////////////////////////////////////////////
public class StraightLineSH extends Line {
 
  public StraightLineSH(Point point1, Point point3, Point point4) {
    super(point1,point3);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
  }

public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1)  || (p == point3 || (p == point4));
     return abhaengig;
  }
//Funktion, die aus den drei gegebenen Punkten alle y-Werte auf der Seitenhalbierenden berechnet
int yWert(int x1, int y1, int x3, int y3,  int x4, int y4, int x){
  float s1 =  float((-2*y1+y3+y4)*x)/float(-2*x1+x3+x4);
  float s2 =  float(-x1*y3+x3*y1+x4*y1-x1*y4)/float(-2*x1+x3+x4);
  float result = s1 + s2;
  return int(result);
}  

public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    //point7 ist wieder als weiterer Punkt auf der Seitenhalbierenden konzipiert (Taste "b")
    point7.setY(round(yWert(point1.getX(), point1.getY(), point3.getX(), point3.getY(),point4.getX(), point4.getY(), point7.getX())));
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }
    
      line(-10,y5,1010, y6);
  
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
     stroke(farbe);
    }
  } 
}

//////////////////////////////////////////////////////////////
//Die Winkelhalbierende, definiert durch point1 als Scheitel
//und point3 und point4, die auf den beiden Schenkeln des Winkels
//liegen. Die beiden letztgenannten Punkte werden so verändert,
//dass sie gleichen Abstand zum Scheitel haben. Danach ist nur 
//noch ein bereits bekanntes "Mittelsenkrechten-Problem" zu lösen
/////////////////////////////////////////////////////////////////
public class StraightLineWH extends StraightLineSH{
 
  private int x3Neu, y3Neu, x4Neu, y4Neu;
 
  
  
  public StraightLineWH(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    x3= point3.getX(); y3= point3.getY();
    x4= point4.getX(); y4= point4.getY();
    x3Neu= round(xWert(x1,y1,x3,y3));
    y3Neu= round(yWert(x1,y1,x3,y3));
    x4Neu= round(xWert(x1,y1,x4,y4));
    y4Neu= round(yWert(x1,y1,x4,y4));     
    y5= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,-10);
    y6= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));
    
  }
  
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1)  || (p == point3 || (p == point4));
     return abhaengig;
  }
  
  float abstand(int x1, int y1, int x2, int y2){
    double d = Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
    return (float) d;
  }
  
  float xWert(int x1, int y1, int x2, int y2){
    float x = x1 + (x2-x1)*100/abstand(x1,y1,x2,y2);
    return x;
  }
  
  float yWert(int x1, int y1, int x2, int y2){
    float y = y1 + (y2-y1)*100/abstand(x1,y1,x2,y2);
    return y;
  }
  
  int funktionWH(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
  float s1 =  float((-2*y1+y2+y3)*x)/float((-2*x1+x2+x3));
  float s2 =  float((-x1*y2+x2*y1+x3*y1-x1*y3))/float((-2*x1+x2+x3));
  float result = s1 + s2;
  return round(result);
}  

  
  public void display(){
   farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);   
    x1= point1.getX(); y1= point1.getY();
    x3= point3.getX(); y3= point3.getY();
    x4= point4.getX(); y4= point4.getY();   
    x3Neu= round(xWert(x1,y1,x3,y3));
    y3Neu= round(yWert(x1,y1,x3,y3));
    x4Neu= round(xWert(x1,y1,x4,y4));
    y4Neu= round(yWert(x1,y1,x4,y4));   
    point7.setY(funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,point7.getX()));
    y5= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,-10);
    y6= funktionWH(x1,y1,x3Neu,y3Neu,x4Neu,y4Neu,1010);
    point5.setX(-10); point5.setY(round(y5));
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
       stroke(color(150,0,0));
    }
   
    line(-10,y5,1010, y6);
    
   
  if (selected) {
      stroke(farbe);
    }
 }
}

//////////////////////////////////////////////////////////
//Damit kann man VertexCurve-Objekte erzeugen  
//und ihr Verhalten studieren
//////////////////////////////////////////////////////////
public class VertexCurve extends GeoObject {
  
  //Attribute
  protected boolean selected = false;
  protected boolean schnittmodus = false; 
  private ArrayList<Point> kurvenPunkte= new ArrayList<Point>();
  private int numberOfPoints;
  private float x = 0;
  private float y = 0;
  
  public VertexCurve(ArrayList<Point> curvePoints) {
     numberOfPoints = curvePoints.size();
      for (int i = 0; i < numberOfPoints; i++) {
        kurvenPunkte.add(curvePoints.get(i));
      }
    }
    
  
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = false;//= (p == point1) || (p == point2);
     for (int i = 0; i < numberOfPoints; i++) {
        abhaengig= (p == kurvenPunkte.get(i));
        if(abhaengig) return abhaengig;
      }
     return abhaengig;  
  }
  
  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }
   
 //display-Methode für VertexCurve
 public void display(){
   //fill(255,0,0); //interessante Erweiterung! Ausprobieren!
   beginShape();
   strokeWeight(1); stroke(200,0,200);
   for(int i = 0; i<numberOfPoints; i++){
     x = kurvenPunkte.get(i).getX();
     y = kurvenPunkte.get(i).getY();
     curveVertex(x,y);      
   }
  endShape();
 } 
}




 

   
    

 
 
 
 
 
 
 